<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"file.lib.php", "format.lib.php", "files"
	);

	Extract (
		URLGetArgs("null/null/action=alpha?path=data")
	);

	// directory scalation
	if (preg_match("/\.\./", $path))
		$path = '';

	$path = rtrim("$path", "/");

	if (file_exists(GEKKO_FILE_ROOT.$path)) {

		switch ($action) {

			case "edit":
				$abs_path = GEKKO_FILE_ROOT.$path;

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "files/admin.$action.tpl");

				// permissions
				$perms = substr(Files::readablePerms(fileperms($abs_path)), 1);
				$level = Array("U", "G", "O");
				$modes = Array("r", "w", "x");

				preg_match_all("/[a-z\-]{3}/", $perms, $perms);

				foreach ($perms[0] as $j => $block) {
					foreach ($modes as $i => $mode) {
						$tpl->set("MODE_".strtoupper($level[$j].$mode), ($mode == $block[$i]));
					}
				}

				$actions = new tplButtonBox();
				$actions->add(
					mklink("index.php/module=admin/base=files", _l("L_FILES"), "files.png"),
					mklink("index.php/module=files?path=".rawurlencode($path), _l("L_DOWNLOAD"), "download.png"),
					mklink("modules/files/main.act.php?action=delete&path=".rawurlencode($path)."&auth={C_AUTH_STR}",_L("L_DELETE"), "delete.png", true)
				);
				$actions = $actions->make();

				$tpl->setArray (
					Array (
						"BLOCK_ICON"	=> Files::mkIcon($abs_path, 16),
						"BLOCK_TITLE"	=> basename($abs_path),
						"ABS_PATH"		=> $abs_path,
						"ACTIONS"		=> $actions,
						"PATH"			=> $path,
						"ACTION"		=> $action,
						"RETURN"		=> ""
					)
				);

				$mcBuff = $tpl->make();
			break;
			default:
				if (is_dir(GEKKO_FILE_ROOT.$path)) {

					$tpl = new ContentBlock();
					$tpl->insert("BLOCK_CONTENT", "files/admin.default.tpl");

					$path .= '/';

					$buff = listdir(GEKKO_FILE_ROOT.$path);

					// listing directories first
					$dirs = Array();
					$files = Array();
					foreach ($buff as $file) {
						$abs_path = GEKKO_FILE_ROOT.$path.$file;
						(is_dir($abs_path)) ? ($dirs[] = $file) : ($files[] = $file);
					}
					$items = array_merge($dirs, $files);

					// total size counter
					$total_size = 0;

					foreach ($items as $file) {

						$abs_path = GEKKO_FILE_ROOT.$path.$file;

						$is_dir = is_dir($abs_path);

						$data = Array (
							"FILENAME"	=> htmlspecialchars($file),
							"PATH"		=> $abs_path,
							"REL_PATH"	=> $path,
							"SIZE"		=> ($size = filesize($abs_path))
						);

						$data["LINK"] = urlevalprototype("index.php/module=".($is_dir ? "admin/base=" : "")."files?path=".rawurlencode($path.$file));

						if (is_writable($abs_path)) {
							$data["BUTTONS"] = new tplButtonBox();
								$data["BUTTONS"]->add(mklink("index.php/module=admin/base=files/action=edit?path=".rawurlencode($path.$file)."", _l("L_EDIT"), "edit.png", false, "icon"));
								$data["BUTTONS"]->add(mklink("modules/files/main.act.php?action=delete&path=".rawurlencode($path.$file)."&auth={C_AUTH_STR}",_L("L_DELETE"), "delete.png", true, "icon"));
							$data["BUTTONS"] = $data["BUTTONS"]->make();
						} else {
							$data["BUTTONS"] = "";
						}

						$tpl->setArray($data, "FILE");
						$tpl->saveBlock("FILE");

						$total_size += (!$is_dir)*$size;
					}

					$tpl->setArray (
						Array (
							"BLOCK_TITLE"	=> _l("L_FILES"),
							"BLOCK_ICON"	=> mkIcon("files.png", 16),
							"ABS_PATH"		=> GEKKO_FILE_ROOT.$path,
							"PATH"			=> $path,
							"ACTION"		=> "upload",
							"RETURN"		=> "",
							"FILES"			=> count($files),
							"ITEMS"			=> count($items),
							"DIRS"			=> count($dirs),
							"TOTAL_SIZE"	=> $total_size
						)
					);

					$mcBuff = $tpl->make();

				} else {
					// todo: download file

				}
			break;
		}
	} else {
		$mcBuff = mkMessageBox("error", "L_FILE_DOESNT_EXISTS");
	}

?>