<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"format.lib.php", "file.lib.php", "files", "third_party/geshi/common.php"
	);

	Extract (
		URLGetArgs ("null/action=alpha?path=data&highlight=int")
	);

	// directory scalation
	if (preg_match("/\.\./", $path))
		$path = "";

	$path = rtrim("$path", '/');

	switch ($action) {
		default:

			if (is_dir(GEKKO_FILE_ROOT.$path)) {

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "files/main.default.tpl");

				$path .= '/';

				// scanning directory contents
				$buff = listdir(GEKKO_FILE_ROOT.$path);

				// listing directories first
				$dirs = Array();
				$files = Array();
				foreach ($buff as $file) {
					if ($file == "uploaded" && conf::getkey("files", "hide_uploads_folder", 1, "b"))
						continue;
					$abs_path = GEKKO_FILE_ROOT.$path.$file;
					(is_dir($abs_path)) ? ($dirs[] = $file) : ($files[] = $file);
				}

				$items = array_merge($dirs, $files);

				// total size counter
				$total_size = 0;
				foreach ($items as $file) {

					$abs_path = GEKKO_FILE_ROOT.$path.$file;

					$is_dir = is_dir($abs_path);

					$data = Array (
						"LINK"		=> urlEvalPrototype("index.php/module=files?path=".rawurlencode($path.$file)),
						"FILENAME"	=> $file,
						"PATH"		=> $abs_path,
						"REL_PATH"	=> $path,
						"SIZE"		=> ($size = filesize($abs_path)),
						"BUTTONS"	=> ""
					);

					$total_size += (!$is_dir)*$size;

					if (conf::Getkey("files", "user_action_buttons", 1, 'b')) {

						$data["BUTTONS"] = new tplButtonBox();

						if (!$is_dir) {
							$data["BUTTONS"]->add(mklink("index.php/module=files?path=".urlencode($path.$file)."", _l("L_DOWNLOAD"), "downloads.png", false, "icon"));
						} else {
							$data["BUTTONS"]->add(mklink("index.php/module=files?path=".urlencode($path.$file)."", _l("L_OPEN"), "open.png", false, "icon"));
						}

						if (conf::Getkey("files", "sintax_highlighter", 1, "b") && geshi_language(file_extension($file))) {
							$data["BUTTONS"]->add(mklink("index.php/module=files?path=".urlencode($path.$file)."&highlight=1", _l("L_HIGHLIGHT"), "highlight.png", false, "icon"));
						}

						$data["BUTTONS"] = $data["BUTTONS"]->make();
					}

					$tpl->setArray($data, "FILE");
					$tpl->saveBlock("FILE");
				}

				$tpl->setArray (
					Array (
						"BLOCK_TITLE"		=> _l("L_FILES"),
						"BLOCK_ICON"		=> mkIcon("files.png", 16),
						"PATH"				=> $path,
						"FILES"				=> count($files),
						"ITEMS"				=> count($items),
						"DIRS"				=> count($dirs),
						"TOTAL_SIZE"		=> $total_size
					)
				);

				$mcBuff = $tpl->make();
			} else if (is_file(GEKKO_FILE_ROOT.$path)) {

				if (conf::Getkey("files", "sintax_highlighter") && $highlight) {

					if (($lang = geshi_language(file_extension($path))) != false) {
						LoadLib ("third_party/geshi/geshi.php");

						$f = fopen(GEKKO_FILE_ROOT.$path, "r");
						$buff = fread($f, filesize(GEKKO_FILE_ROOT.$path));
						fclose($f);

						header("content-type: text/html; charset=utf-8");
						echo geshi_highlight($buff, $lang);

						shutdown();
					}
				}

				switch (file_extension($path)) {
					case "php": case "pl": case "py":
						// this can be harmful if interpreted by the server or this doesn't need to
						// be displayed
						header("Content-disposition: filename=".urlencode(basename($path)));
						header("Content-type: application/x-octec-stream");
						$f = fopen(GEKKO_FILE_ROOT.$path,"r");
						fpassthru($f);
						fclose($f);
						shutdown();
					default:
						$path = trim($path, "/");
						header("Location: "._l("C_SITE.REL_URL")."data/files/".$path);
						shutdown();
					break;
				}
			}
		break;
	}

?>