<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_SOURCE_DIR."lib/auth.inc.php";

	// this script runs only form administrative group
	if (!gauth("files"))
		abort(accessDenied());

	LoadLib (
		"template.lib.php", "gzenc.lib.php", "file.lib.php", "image.lib.php", "files"
	);

	varImport("path", "command", "argv");

	if (preg_match("/\.\./", $path))
		$path = "";

	$dir = GEKKO_DATA_DIR.preg_replace("/\/*$/", "", $path);

	if (file_exists($dir)) {

		$tpl = new blockWidget('files/list.xml.tpl');

		if (is_dir($dir)) {

			if ($command) {

				foreach ($argv as $value)
					if (preg_match("/\.\./", $value))
						die("wtf?");

				switch ($command) {
					case "mkdir":
						mkdir("$dir/$argv[0]");
					break;
					case "mkfile":
						touch("$dir/$argv[0]");
					break;
					case "download":
						saveFile($argv[0], "data/$path");
					break;
					case "move":
						rename("$dir/{$argv[0]}", allocate_basename("$dir/{$argv[1]}/", $argv[0], true));
					break;
					case "copy":
						$source = GEKKO_DATA_DIR."/{$argv[0]}";
						$destination = allocate_basename(GEKKO_DATA_DIR."{$argv[1]}/", basename($argv[0]), true);

						files::copy($source, $destination);
					break;
					case "cut":
						$source = GEKKO_DATA_DIR."/data/{$argv[0]}";
						$destination = allocate_basename(GEKKO_DATA_DIR."data/{$argv[1]}/", basename($argv[0]), true);

						files::copy($source, $destination);
						files::delete($source);
					break;
					case "delete":
						files::delete(GEKKO_DATA_DIR."/{$argv[0]}");
					break;
				}
			}

			// directory listing
			$files = listdir($dir);

			$dlist = array();
			$flist = array();

			foreach ($files as $file) {
				$fullpath = "$dir/$file";

				$type = guessFileType($fullpath);

				$thumb = "";
				if ($type == "image") {
					$thumb = "data/thumbs/".thumbName($fullpath);
					if (!file_exists(GEKKO_USER_DIR.$thumb)) {
						$thumb = "";
					} else {
						$size = getimagesize(GEKKO_USER_DIR.$thumb);
						$thumb .= ":{$size[0]}:{$size[1]}";
					}
				}

				$row = array (
					"IS_DIRECTORY" => (int)is_dir($fullpath),
					"IS_WRITABLE" => (int)is_writable($fullpath),
					"SIZE" => filesize($fullpath),
					"TYPE" => $type,
					"EXTENSION" => file_extension($fullpath),
					"ICON" => files::fetchIcon($fullpath, 16),
					"THUMBNAIL" => $thumb,
					"NAME" => $file
				);
				if ($row["IS_DIRECTORY"])
					$dlist[] = $row;
				else
					$flist[] = $row;
			}

			$flist = array_merge($dlist, $flist);
			foreach ($flist as $row) {
				$tpl->setArray($row, "FILE");
				$tpl->saveBlock("FILE");
			}

		} else {

			$file = $dir;

			$dir = dirname($file);
			$path = dirname($path);

			loadLib("files");

			$thumb = files::createThumbnail($file);

			$data = Array (
				"THUMBNAIL" => $thumb,
				"NAME" => basename($file),
				"SIZE" => filesize($file),
				"TYPE" => guessFileType($file),
				"IS_WRITABLE" => (int)is_writable($file),
				"PERMISSIONS" => files::readablePerms($file)
			);

			$tpl->setArray($data, "INFO");
			$tpl->saveBlock("INFO");
		}

		$data = Array (
			"IS_WRITABLE" => (int)is_writable($dir),
			"NAME" => $path,
			"ROOT" => GEKKO_FILE_ROOT
		);

		$tpl->setArray($data);
		$tpl->save();

		gzinit();
			header("content-type: text/xml; charset=utf-8");
			echo $tpl->make();
		gzoutput();
	}
?>